package com.interdataworking.gateway;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import java.util.*;
import java.io.*;

import com.interdataworking.mm.alg.*;

public class MapToText implements RDFSerializer {

  public void serialize(Model m, Writer w) throws ModelException, IOException {

    List l = MapPair.toMapPairs(m);
    Object[] a = l.toArray();
    MapPair.sortGroup(a);

    List list = Arrays.asList(a);
    Iterator it = list.iterator();
    //    List list = MapPair.toMapPairs(m);

    // determine indent
    int id1 = 0, id2 = 0, id3 = 0;
    while(it.hasNext()) {

      MapPair p = (MapPair)it.next();
      id1 = Math.max(id1, p.getLeft().toString().length() + 2);
      id2 = Math.max(id2, id1 + p.getRight().toString().length() + 2);
      id3 = Math.max(id3, id2 + String.valueOf(p.sim).length() + 2);
    }

    it = list.iterator();
    while(it.hasNext()) {

      MapPair p = (MapPair)it.next();
      int i = write(0, 0, p.getLeft().toString(), w);
      i = write(id1, i, p.getRight().toString(), w);
      i = write(id2, i, String.valueOf(p.sim), w);
      i = write(id3, i, String.valueOf(p.inverse), w);
      w.write('\n');
      w.flush();
    }
    w.write("Total map entries: " + list.size() + "\n");
    w.flush();
  }

  public static int write(int targetIndent, int currentIndent, String s, Writer w) throws IOException {

    for(int i = currentIndent; i < targetIndent; i++)
      w.write(' ');
    w.write(s);
    return Math.max(targetIndent, currentIndent) + s.length();
  }
}
