package com.interdataworking.gateway;

import java.io.*;
import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.interpreter.*;

public class Obj2Text implements UntypedGateway, RDFSerializer {

  List empty() {

    List l = new ArrayList();
    l.add(""); // empty string
    l.add(new HashMap()); // empty boxes
    return l;
  }

  public List execute(List input) throws ModelException {

    Model m = (Model)input.get(0);

    LanguageCallback cb = null;
    cb = ((ParameterList)input).getExecutionContext().getLanguageCallback(m);

    if(cb == null) {
      System.err.println("[Obj2Text] No callback found, empty serialization!");
      return empty();

    } else {

      UntypedGateway gw = cb.defaultSerializer();
      if(gw == null) {
	System.err.println("[Obj2Text] Callback does not implement, empty serialization!");
	return empty();

      } else
	return gw.execute(input);
    }
  }

  public void serialize(Model model, Writer out) throws SerializationException, IOException, ModelException {

    Model m = model;

    LanguageCallback cb = Interpreter.getExecutionContext().getLanguageCallback(m);

    if(cb == null) {
      System.err.println("[All] No callback found, empty serialization!");

    } else {

      List par = new ArrayList();
      par.add(model);
      List l = cb.defaultSerializer().execute(par);
      out.write((String)l.get(0));
    }
  }


  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }
  
  public int getMinOutputLen() { return 1; }
  
  public int getMaxOutputLen() { return 2; }

}
