package com.interdataworking.gateway;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import java.util.*;
import java.io.*;

public class SelectorToText implements RDFSerializer {

  public void serialize(Model m, Writer w) throws ModelException, IOException {

    MapVocabulary M = new MapVocabulary(m.getNodeFactory());

    Set s = M.asSet(m);

    Iterator it = s.iterator();
    while(it.hasNext()) {

      RDFNode p = (RDFNode)it.next();
      w.write(p.toString());
      w.write('\n');
      w.flush();
    }
    w.write("Total selector entries: " + s.size() + "\n");
    w.flush();
  }
}
