package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

public class Compose implements UntypedGateway {

  public static List compose(List m1, List m2) {

    Map table = new HashMap();

    for(int i=0; i < m1.size(); i++) {

      MapPair p1 = (MapPair)m1.get(i);

      for(int j=0; j < m2.size(); j++) {

	MapPair p2 = (MapPair)m2.get(j);
	if(p1.getRight().equals(p2.getLeft())) {

	  // add a new mapping entry
	  MapPair pp = new MapPair(p1.getLeft(), p2.getRight());
	  MapPair p = (MapPair)table.get(pp);
	  if(p == null) {
	    p = pp;
	    table.put(p, p);
	  }

	  // update similarity
	  p.sim += p1.sim * p2.sim; // why not?
	  //	  p.inverse = p1.inverse ^ p2.inverse; // xor
	  //	  p.sim = p.NULL_SIM; // undefined, NULL
	  p.inverse = p1.inverse | p2.inverse; // or
	}
      }
    }

    List res = new ArrayList(table.values());
    MapPair.normalize(res);
    return res;
  }

  public List execute(List input) throws ModelException {

    Model src1 = (Model)input.get(0);
    Model src2 = (Model)input.get(1);

    List l1 = MapPair.toMapPairs(src1);
    List l2 = MapPair.toMapPairs(src2);
    List res = compose(l1, l2);

    ArrayList l = new ArrayList();
    Model dest = MapPair.asModel(src1.create(), res.toArray());
    l.add(dest);
    return l;
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
