package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import com.interdataworking.mm.interpreter.*;

//import edu.stanford.db.rdf.util.Aggregator;

/**
 * Given a set of forward and backward arcs, generates a map of
 * <obj, dependent obj>
 **/

public class Dependencies implements UntypedGateway {

  public List execute(List input) throws ModelException {

    Model m = (Model)input.get(0);

    LanguageCallback cb = null;
    cb = ((ParameterList)input).getExecutionContext().getLanguageCallback(m);

    Model result = null;

    if(cb == null) {
      System.err.println("[Dependencies] No callback found, empty dependencies!");
      result = m.create();

    } else {

      result = MapPair.asModel(m, cb.getDependencies(m));
      if(result == null) {
	System.err.println("[Dependencies] Callback does not implement, empty dependencies!");
	result = m.create();
      }
    }

    ArrayList l = new ArrayList();
    l.add(result);
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }
  
  public int getMinOutputLen() { return 1; }
  
  public int getMaxOutputLen() { return 1; }
}
