package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

public class MapStatistics implements UntypedGateway {

  public static String getMapStatistics(List actual) {

    double sum = 0;
    double cardProd = 0;
    double cardSum = 0;

    Set left = new HashSet();
    Set right = new HashSet();
    
    for(int i=0; i<actual.size(); i++) {

      MapPair p = (MapPair)actual.get(i);

      left.add(p.getLeftNode());
      right.add(p.getRightNode());

      sum += p.sim;

      MapPair.Card c = p.getCardinality(actual);
      cardProd += p.sim / (c.left * c.right);
      cardSum += p.sim * 2 / (c.left + c.right);
    }

    return
      "Map statistics: sum: " + sum + ", invProd: " + cardProd + ", invAvg: " + cardSum + ", totalCard: " + (left.size() + right.size());
  }

  public List execute(List input) throws ModelException {

    Model actual = (Model)input.get(0);
    List l1 = MapPair.toMapPairs(actual);

    System.out.println(getMapStatistics(l1));

    return new ArrayList();
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 0; }

  public int getMaxOutputLen() { return 0; }

}
