package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

/**
 * Returns a selector, ie. statements (r, loop, r)
 */

public class Range implements UntypedGateway {

  boolean addDomain = false;
  boolean addRange = true;

  public Resource getSearchPredicate(MapVocabulary M) {

    return M.dest;
  }

  public Model getRange(Model map) throws ModelException {

    NodeFactory f = map.getNodeFactory();
    MapVocabulary M = new MapVocabulary(f);
    Model result = map.create();

    Enumeration en = map.find(null, getSearchPredicate(M), null).elements();
    while(en.hasMoreElements()) {

      Statement st = (Statement)en.nextElement();

      if(addRange && st.object() instanceof Resource && !(st.object() instanceof Statement)) {
	Resource r = (Resource)st.object();
	result.add(f.createStatement(r, M.loop, r));
      }

      if(addDomain && !(st.subject() instanceof Statement)) {
	Resource r = st.subject();
	result.add(f.createStatement(r, M.loop, r));
      }
    }

    return result;
  }

  public List execute(List input) throws ModelException {

    Model map = (Model)input.get(0);
    //    Model src = (Model)input.get(1);

    Model range = getRange(map);

    ArrayList l = new ArrayList();
    l.add(range);
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
