package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
//import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
//import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

//import edu.stanford.db.rdf.util.Aggregator;

public class Reachable implements UntypedGateway {

  public static Set reachable(Set selector, Collection map) throws ModelException {

    Set result = new HashSet();
    Map l2r = MapPair.toJavaSetMap(map, false);

    for(Iterator it = selector.iterator(); it.hasNext();)
      reachable0((RDFNode)it.next(), l2r, result);

    return result;
  }

  public static void reachable0(Object r, Map l2r, Set result) throws ModelException {

    if(r instanceof Literal || r instanceof Statement)
      return;

    if(!result.add(r))
      return; // already added this node and all nodes reachable from it

    Set s = (Set)l2r.get(r);

    if(s == null)
      return;

    for(Iterator is = s.iterator(); is.hasNext();) {

      MapPair t = (MapPair)is.next();
      reachable0(t.getRight(), l2r, result);
    }
  }

  public List execute(List input) throws ModelException {

    Model selectorM = (Model)input.get(0);
    Model mapM = (Model)input.get(1);

    MapVocabulary M = new MapVocabulary(mapM.getNodeFactory());
    Set selector = M.asSet(selectorM);
    List map = MapPair.toMapPairs(mapM);

    Set result = reachable(selector, map);
    Model resultM = selectorM.create();
    M.asModel(resultM, result);

    ArrayList l = new ArrayList();
    l.add(resultM);
    return l;
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }
  
}
