package com.interdataworking.mm.alg;

import com.interdataworking.*;
import com.interdataworking.mm.*;
//import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
//import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

//import edu.stanford.db.rdf.util.Aggregator;

public class RestrictDomain implements UntypedGateway {

  boolean restrictDomain = true; // otherwise, range

  /**
   * selects all information that is minimal and absolutely necessary
   * for the referenced nodes to make sense
   */
  public List restrict(List map, Set selector) throws ModelException {

    List result = new ArrayList();

    for(Iterator it = map.iterator(); it.hasNext();) {

      MapPair p = (MapPair)it.next();
      if( (restrictDomain && selector.contains(p.getLeft())) ||
	  (!restrictDomain && selector.contains(p.getRight())) )
	result.add(p);
    }

    return result;
  }

  public List execute(List input) throws ModelException {

    Model mapM = (Model)input.get(0);
    Model selectorM = (Model)input.get(1);

    List map = MapPair.toMapPairs(mapM);
    MapVocabulary M = new MapVocabulary(mapM.getNodeFactory());
    Set selector = M.asSet(selectorM);

    Model result = MapPair.asModel(mapM, restrict(map, selector));

    ArrayList l = new ArrayList();
    l.add(result);
    return l;
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }
  
}
