package com.interdataworking.mm.alg;

import com.interdataworking.mm.NodeFilter;
import org.w3c.rdf.model.*;
import com.interdataworking.gateway.sqlddl.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

// ignore everything apart of Tables, Columns, Keys and ReferentialConstraints

public class SQLDDLNodeFilter implements NodeFilter {

  Set valid = new HashSet();

  public SQLDDLNodeFilter(Model m) throws ModelException {

    SQLDDLVocabulary R = new SQLDDLVocabulary(m.getNodeFactory());

    Set validTypes = new HashSet();
    validTypes.add(R.TableDef);
    validTypes.add(R.ColDef);
//     validTypes.add(R.PrimaryKey);
//     validTypes.add(R.UniqueKey);
//     validTypes.add(R.ReferentialConstraint);

    // collect valid nodes
    Enumeration en = m.elements();
    while(en.hasMoreElements()) {

      Statement st = (Statement)en.nextElement();

      //      System.err.println("SQL Examining: " + st);

      if(RDF.type.equals(st.predicate())) {

	//	System.err.println("     SQL type matched: " + st);

	Resource type = (Resource)st.object();


// 	System.err.println("     CHECKING: <" + type.getNamespace() + "," + type.getLocalName() +
// 			   "( " + type.getClass() + " > against <" +
// 			   R.ColDef.getNamespace() + "," + R.ColDef.getLocalName() + " (" + R.ColDef.getClass() + ")");


	if(validTypes.contains(type)) {
	  valid.add(st.subject());
	  //	  System.err.println("        SQL Valid: " + st.subject());
	}
      }
    }
  }

  public boolean filterOutNode(RDFNode n) {

    boolean b = !valid.contains(n);

    //    System.err.println("KEEP: " + n + ": " + !b);

    return b;
  }
  
}
