package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

public class SetDifference implements UntypedGateway {

  public List execute(List input) throws ModelException {

    Model dest = ((Model)input.get(0)).duplicate();

    if(dest instanceof MapPair.ModelWrapper) {

      // special case: union of mappings
      Set s = new HashSet(MapPair.toMapPairs(dest));
      for(int i = 1; i < input.size(); i++)
	s.removeAll(MapPair.toMapPairs((Model)input.get(i)));

      dest = MapPair.asModel(dest, s);

    } else {

      // arbitrary graphs

      for(int i = 1; i < input.size(); i++)
	SetOperations.subtract(dest, (Model)input.get(i));
    }

    ArrayList l = new ArrayList();
    l.add(dest);
    return l;
  }


  public int getMinInputLen() { return 2; }
  
  public int getMaxInputLen() { return 100; }
  
  public int getMinOutputLen() { return 1; }
  
  public int getMaxOutputLen() { return 1; }

}
