package com.interdataworking.mm.gui;

import javax.swing.*;
import javax.swing.tree.*;
//import javax.swing.event.*;
//import javax.swing.text.*;
//import javax.swing.border.*;
//import javax.swing.colorchooser.*;
//import javax.swing.filechooser.*;
import javax.swing.table.*;
import javax.swing.event.ChangeEvent;
import javax.accessibility.*;

import java.awt.Event;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.BorderLayout;
import java.awt.Point;
import java.awt.Color;
import java.awt.Container;
import java.awt.Component;
import java.awt.Insets;
import java.awt.event.*;
import java.awt.geom.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import java.applet.*;
import java.net.*;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;

public class AdjustMapping implements UntypedGateway {

  boolean RELATIVE_SIMILARITY = true; // otherwise, absolute
  boolean WEIGHTS_ON_RED_ARCS = false; // otherwise, no values

  int MAX_SUGGESTIONS = 3;
  boolean isModal = true; // whether JDialog is modal
  Object lock = new Object(); // lock for modal

  ArrowPanel arrowPanel;
  //  JDialog dialog; // for repainting
  
  MapPane[] panes = new MapPane[2]; // 0 and 1 for left and right

//   JPanel left, right;
//   Map l2j = new HashMap(), r2j = new HashMap(); // RDFNode -> JComponent (PointerBox)
  Map map = new HashMap(), multimap, hintMap = new HashMap(), redMap = new HashMap(); // self map on pairs

  MouseListener ml;

  //  JComponent focused;

  /**
   * main method allows us to run as a standalone demo.
   */
  public static void main(String[] args) throws Exception {

    RDFFactory rf = new RDFFactoryImpl();
    NodeFactory f = rf.getNodeFactory();

    String ltext = "This is \n an example\n of some\ntext";

    Map llines = new HashMap();

    llines.put(f.createResource("1"), new TLine(1, 0, 4));
    llines.put(f.createResource("2"), new TLine(2, 4, 6));
    llines.put(f.createResource("3"), new TLine(3, 3, 6));
    
    String rtext = "This is \n another example\n of some\ntext";

    Map rlines = new HashMap();

    rlines.put(f.createResource("10"), new TLine(1, 0, 4));
    rlines.put(f.createResource("20"), new TLine(2, 4, 6));
    rlines.put(f.createResource("30"), new TLine(3, 3, 6));

    List multimap = new ArrayList();
    multimap.add(new MapPair(f.createResource("1"), f.createResource("10")));
    multimap.add(new MapPair(f.createResource("1"), f.createResource("20")));
    multimap.add(new MapPair(f.createResource("2"), f.createResource("20")));
    multimap.add(new MapPair(f.createResource("2"), f.createResource("30")));

    List map = new ArrayList();
    map.add(new MapPair(f.createResource("1"), f.createResource("10")));
    map.add(new MapPair(f.createResource("2"), f.createResource("20")));

    AdjustMapping rm = new AdjustMapping();
    rm.adjustMapping(ltext, llines, rtext, rlines, multimap, map, "Sample mapping");

    System.err.println("Done");
  }

    /*
    FocusListener fl = new FocusListener() {

	public void focusGained(FocusEvent e) {
	  System.err.println("Focus gained");
	}

	public void focusLost(FocusEvent e) {
	}

      };
    */

  public static MapPane createPane() {

    MapPane pane = new MapPane();

    pane.panel = new JPanel();
//     JPanel ins = new JPanel() {
// 	Insets insets = new Insets(30, 30, 30, 30);
// 	public Insets getInsets() {
// 	  return insets;
// 	}
//       };

    pane.panel.setBackground(Color.white);
    //    left.setLayout(new BoxLayout(left, BoxLayout.X_AXIS));
    //    left.setLayout(new BorderLayout()); //new OverlayLayout(left));
    //    left.setLayout(new OverlayLayout(left));
    pane.panel.setLayout(new EmptyLayout());
    pane.scroller = new JScrollPane(pane.panel);

    return pane;
  }

//   static void addToMap(Map map, RDFNode n1, RDFNode n2) {

//     MapPair p = new MapPair(n1, n2);
//     map.put(p, p);
//   }

  public AdjustMapping() {
  }

  void setMappings() {

    calcUnmatched();
    arrowPanel.setMappings(redMap, hintMap, panes[0].r2j, panes[1].r2j);
    //    dialog.repaint(); // for scrollers
    panes[0].scroller.invalidate();
    panes[1].scroller.invalidate();
    panes[0].scroller.repaint();
    panes[1].scroller.repaint();
  }

  public void adjustMapping(String ltext, Map llines, String rtext, Map rlines, List multimapP, List mapP, String windowTitle) throws ModelException {

    //    multimapP = MapPair.prune(multimapP, MAX_SUGGESTIONS);
    this.map = mapP == null ? new HashMap() : MapPair.toSelfMap(mapP, false);
    this.multimap = multimapP == null ? new HashMap() : MapPair.toSelfMap(multimapP, false);

    JFrame frame = new JFrame();
    JDialog dialog = new JDialog(frame, "Mapping Editor" + (windowTitle != null ? ": " + windowTitle : ""), false);
    /*
 {

	public boolean handleEvent(Event ev) {

	  if(ev.id == Event.WINDOW_DESTROY) {
	    this.dispose();
	    return true;
	  }
	  return super.handleEvent(ev);
	}
      };
    */
    // non-modal in the AWT sense (blocking input to other windows)

    dialog.addWindowListener(new AMWindowAdapter(this.lock));

    this.arrowPanel = new ArrowPanel();
    // show % only if relative similarity used
    this.arrowPanel.WEIGHTS_IN_PERCENT = RELATIVE_SIMILARITY;
    this.arrowPanel.WEIGHTS_ON_RED_ARCS = WEIGHTS_ON_RED_ARCS;
    //     arrowPanel.setLayout(new BoxLayout(arrowPanel, BoxLayout.X_AXIS));
    arrowPanel.setLayout(new BorderLayout());

    //    JPanel opanel = new JPanel();
    //    opanel.setLayout(new OverlayLayout(opanel));

    for(int i=0; i <= 1; i++) {

      panes[i] = createPane();
      panes[i].mouseListener = new AMMouseAdapter(i);
    }

    BoxUpdater lbu = new AMBoxUpdater(0);

    panes[0].panel.add(new ImageComponent(ltext, llines, lbu));

    BoxUpdater rbu = new AMBoxUpdater(1);


    panes[1].panel.add(new ImageComponent(rtext, rlines, rbu));

    calcMaps(null, 0);
    setMappings();

    JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, panes[0].scroller, panes[1].scroller);
    splitPane.setContinuousLayout(true);
    splitPane.setOneTouchExpandable(true);
    splitPane.setDividerLocation(400);

    arrowPanel.add(splitPane);
    //    arrowPanel.add(lscroll);
    //    arrowPanel.add(rscroll);
    arrowPanel.setScrollPanes(panes[0].scroller, panes[1].scroller);

    dialog.getContentPane().add(arrowPanel);

    //    dialog.pack();
    dialog.setSize(800, 600); // dialog.getHeight());
    dialog.setLocation(100, 100);
    splitPane.setDividerLocation(dialog.getWidth() / 2);
    dialog.setVisible(true);

    //    dialog.pack();
//     int w = Math.min(dialog.getWidth(), 800);
//     int h = Math.min(dialog.getHeight(), 600);
//     System.err.println("====== DIALOG w=" + w + ", h=" + h);
//     dialog.setSize(w, h);
//     dialog.setModal(true);
//     dialog.show();
//     dialog.invalidate();
//     dialog.repaint();

    if(isModal) { // block until notified
      waitOnLock(lock);
    }

  }

  public static void waitOnLock(Object lock) {

    try {
      synchronized (lock) { lock.wait(); }
    } catch (InterruptedException any) {}
  }

  void calcUnmatched() {

    // first, mark all boxes as unmatched

    for(int i=0; i <= 1; i++) {
      if(panes[i].r2j != null)

	for(Iterator it = panes[i].r2j.values().iterator(); it.hasNext();) {

	  PointerBox b = (PointerBox)it.next();
	  b.setUnmatched(true);
	}
    }

    // mark unmatched nodes left
    boolean hasDirectedArcs = false;

    for(Iterator it = map.values().iterator(); it.hasNext();) {
      
      MapPair p = (MapPair)it.next();
      if(p.inverse)
	hasDirectedArcs = true;
      PointerBox b = (PointerBox)panes[0].getComponent(p.getLeft());
      if(b != null)
	b.setUnmatched(false);
      b = (PointerBox)panes[1].getComponent(p.getRight());
      if(b != null)
	b.setUnmatched(false);
    }

    arrowPanel.setDrawArrows(hasDirectedArcs);
  }

  // first parameter: object in mapping
  void calcMaps(Object n, int paneId) {

    //    System.err.println("Calc maps for " + n);

    if(n == null) {
      redMap.clear();
      redMap.putAll(map);
    } else
      calcMap(map, redMap, n, paneId, false, Integer.MAX_VALUE);

    calcMap(multimap, hintMap, n, paneId, RELATIVE_SIMILARITY, MAX_SUGGESTIONS);
  }

  void calcMap(Map src, Map dest, Object n, int paneId, boolean relative, int maxSuggestions) {

    dest.clear();
    if(n == null)
      return;

    List list = new ArrayList();

    for(Iterator it = src.values().iterator(); it.hasNext();) {

      MapPair p = (MapPair)it.next();
      if( (paneId == 0 && p.getLeft().equals(n)) ||
	  (paneId == 1 && p.getRight().equals(n)) ) {

	if(relative)
	  p = p.duplicate();

	list.add(p);
      }
    }

    MapPair[] arr = new MapPair[list.size()];
    list.toArray(arr);
    MapPair.sort(arr);

    // pick top hints
    for(int i=0; i < Math.min(arr.length, maxSuggestions); i++)
      dest.put(arr[i], arr[i]);

    if(relative)
      MapPair.normalize(dest.values());
  }

  public static Map invert(Map map) {

    Map result = new HashMap();

    for(Iterator it = map.entrySet().iterator(); it.hasNext();) {

      Map.Entry e = (Map.Entry)it.next();
      result.put(e.getValue(), e.getKey());
    }
    return result;
  }

  class AMMouseAdapter extends MouseAdapter {

    int paneId;

    public AMMouseAdapter(int paneId) {

      this.paneId = paneId;
    }

    public void mouseEntered(MouseEvent e) {
      //	  System.err.println("Mouse entered");
      
      PointerBox p = (PointerBox)e.getComponent();
      p.mouseOver = true;
      //	  p.invalidate();
      arrowPanel.repaint();
    }
    
    public void mouseExited(MouseEvent e) {
      //	  System.err.println("Mouse exited");
      PointerBox p = (PointerBox)e.getComponent();
      p.mouseOver = false;
      //	  p.invalidate();
      arrowPanel.repaint();
    }
    
    public void mouseClicked(MouseEvent e) {
      
      if(!e.isControlDown() && !e.isShiftDown()) { // select node

	PointerBox p = (PointerBox)e.getComponent();

	if(panes[paneId].getNode(p).equals(panes[paneId].selected)) // already selected, unselect
	  p = null;

	panes[paneId].select(p);
	panes[1 - paneId].select(null);

	// recalculate hint map
	calcMaps(panes[paneId].selected, paneId);
	setMappings();

	arrowPanel.repaint();

      } else {

	Object src = panes[paneId].getNode(e.getComponent());
	Object dest = panes[1 - paneId].selected;
	boolean hasSelected = dest != null;

	if(e.isShiftDown() && hasSelected) { // toggle
	
	  if(paneId == 1) { // swap
	    Object tmp = src; src = dest; dest = tmp;
	  }

	  MapPair p = new MapPair(src, dest, 1.0, false); // by default not inverse
	  MapPair prev = (MapPair)map.get(p);
	  if(prev == null) { // does not exist
	    map.put(p, p);
	    redMap.put(p, p);
	  } else { // already there
	    if(!prev.inverse) {
	      prev.inverse = true;
	      prev.sim = 1.0; // has been confirmed by user
	      //	      arrowPanel.setDrawArrows(true);
	    } else {
	      map.remove(prev);
	      redMap.remove(p);
	    }
	  }
	  calcUnmatched();
	  arrowPanel.repaint();

	} else if(e.isControlDown()) { // remove all candidates

	  for(Iterator it = map.values().iterator(); it.hasNext();) {
	    
	    MapPair p = (MapPair)it.next();
	    if((paneId == 0 && src.equals(p.getLeft())) ||
	       (paneId == 1 && src.equals(p.getRight()))) {
	      it.remove();
	      redMap.remove(p);
	    }
	  }
	  calcUnmatched();
	  arrowPanel.repaint();
	}
      }

      //	  System.err.println("Clicked " + e.getClickCount() + " at " + e.getX() + ", " + e.getY() + " : " + p.hasFocus());
    }
  }

  class AMBoxUpdater implements BoxUpdater {

    int paneIdx;

    public AMBoxUpdater(int paneIdx) {

      this.paneIdx = paneIdx;
    }
	
    public void updateBoxes(Map boxes, Object src) {

      MapPane pane = panes[paneIdx];

      for(Iterator it = boxes.values().iterator(); it.hasNext();) {

	JComponent box = (JComponent)it.next();
	pane.panel.add(box, 0);
	box.addMouseListener(pane.mouseListener);
      }
      pane.r2j = boxes;
      pane.j2r = invert(boxes);

      setMappings();
    }
  }

  static class MapPane {

    JPanel panel;
    JScrollPane scroller;
    Map r2j, j2r;
    MouseListener mouseListener;
    Object selected;

    public Object getNode(Component c) {

      return j2r != null ? (RDFNode)j2r.get(c) : null;
    }

    public Component getComponent(Object n) {

      return r2j != null ? (Component)r2j.get(n) : null;
    }

    public void select(Component c) {

      PointerBox prev = (PointerBox)getComponent(selected);
      if(prev != null) { // unselect
	prev.selected = false;
      }

      if(c != null) {
	((PointerBox)c).selected = true;
	selected = getNode(c);
      } else
	selected = null;
    }
  }

  static class AMWindowAdapter extends WindowAdapter {

    Object lock;

    public AMWindowAdapter(Object lock) {

      this.lock = lock;
    }

    public void windowClosing(WindowEvent e) {
      
      windowClosed(e);
    }

    public void windowClosed(WindowEvent e) {
      
      // proceed with execution, unblock
      //      System.err.println("Notifying!");
      synchronized(lock)
	{ lock.notify(); }
      Thread.yield();
    }
  }

  /**
   * Parameters:
   * (string1, lines1, string2, lines2, multimap, filteredMap)
   * Returns:
   *  map
   */
  public List execute(List input) throws ModelException {

    String ltext = (String)input.get(0);
    Map llines = (Map)input.get(1);

    String rtext = (String)input.get(2);
    Map rlines = (Map)input.get(3);

    Model multimapM = (Model)input.get(4);
    List multimap = MapPair.toMapPairs(multimapM);
    Model mapM = (Model)input.get(5);
    List map = MapPair.toMapPairs(mapM);

    String windowTitle = null;
    if(input.size() > 6)
      windowTitle = (String)input.get(6);

    adjustMapping(ltext, llines, rtext, rlines, multimap, map, windowTitle);

    List result = new ArrayList();
    Model forEmpty = multimapM != null ? multimapM : (mapM != null ? mapM : new RDFFactoryImpl().createModel());
    result.add(MapPair.asModel(forEmpty, this.map.values()));
    //    result.add(MapPair.asModel(forEmpty, MapPair.replacementMap(this.map.values())));

    return result;
  }

  public int getMinInputLen() { return 6; }

  public int getMaxInputLen() { return 7; }

  public int getMinOutputLen() { return 2; }

  public int getMaxOutputLen() { return 2; }

  
}
