package com.interdataworking.mm.interpreter;

import org.xml.sax.SAXException;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import com.interdataworking.mm.interpreter.parser.*;
import com.interdataworking.mm.gui.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;

public class Interpreter {

  static ExecutionContext ctx;
  static RDFFactory rf = new RDFFactoryImpl();


  // FIXME: temporary hack used by Obj2Text
  public static ExecutionContext getExecutionContext() {

    return ctx;
  }

  public static void exec(String fileName) throws Exception {

    try {

      ctx = new ExecutionContext();
      Resource start = null;
      
      try {

	ctx.setScriptModel(rf.createModel());
	start = ScriptParser.parseIt(fileName, ctx);

      } catch (SAXException ex) {
	throw ex.getException() != null ? ex.getException() : ex;
      }

      //    RDFUtil.printStatements(ctx.getScriptModel(), System.out);
      //    RDFUtil.dumpModel(ctx.getScriptModel(), System.out, rf.createSerializer());
      
      if(start != null) {
	//      ctx.log("-- VALIDATE --\n");
	ctx.validate(start);
	//      ctx.log("-- EXECUTE  --\n");
	ctx.run(start);
      }

    } catch (Throwable any) {

      any.printStackTrace(System.err);

    } finally {

      System.err.println("Interpreter: done");
    }
  }

  static File currentDir = null;

  public static boolean execChooser() throws Exception {

    JFileChooser chooser = new JFileChooser();

    ExampleFileFilter filter = new ExampleFileFilter("mm", "Model Management Scripts");
    chooser.setFileFilter(filter);

    if(currentDir != null)
      chooser.setCurrentDirectory(currentDir);

    int retval = chooser.showDialog(null, null);
    if(retval == JFileChooser.APPROVE_OPTION) {

      File theFile = chooser.getSelectedFile();
      exec(theFile.getPath());
      currentDir = chooser.getCurrentDirectory();
      return true;
    }
    return false;
  }

  public static void main(String args[]) throws Exception {

    if(args.length == 0) {

      while(execChooser());

    } else {

      File f = new File(args[0]);

      if(f.isDirectory()) {

	currentDir = f;
	while(execChooser());

      } else {

	for(int i=0; i < args.length; i++)
	  exec(args[i]);
      }
    }
    System.exit(0);
  }
}
