/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */

package edu.stanford.db.rdf.query;

import org.w3c.rdf.model.*;
import java.util.*;

/**
 *
 * @see org.w3c.tools.crypt.DigestUtil
 * @see org.w3c.rdf.util.RDFDigestUtil
 *
 * @author Sergey Melnik <melnik@db.stanford.edu> */

public interface NodeIterator {

  boolean next() throws ModelException;

  RDFNode get(String var) throws ModelException;

  /**
   * The map returned here is read-only.
   * Never modify it!
   */
  Map getAll() throws ModelException;

  int getCost();

  void reset() throws ModelException;

  // pass a new model for processing
  void reset(Model m) throws ModelException;

  void set(String var, RDFNode value) throws ModelException;
}
