package edu.stanford.db.rdf.query.conditions;

import edu.stanford.db.rdf.query.*;
import org.w3c.rdf.model.*;

/**
 * Unequality with a constant
 */
public class NotEqualC implements ConditionEvaluator {

  RDFNode constant;

  public NotEqualC(RDFNode constant) {

    this.constant = constant;
  }

  public int getArity() {

    return 1;
  }

  public boolean holds(RDFNode[] n) {

    return
      (constant == null && n[0] != null) ||
      (constant != null && n[0] == null) ||
      (constant != null && n[0] != null && !constant.equals(n[0]));
  }
}
