package edu.stanford.db.rdf.query.conditions.numeric;

import edu.stanford.db.rdf.query.*;
import org.w3c.rdf.model.*;

/**
 * Numeric equality. For example, 01 == 001
 */
public class EqualNum implements ConditionEvaluator {

  public int getArity() {

    return 2;
  }

  public boolean holds(RDFNode[] n) {

    if(n[0] != null && n[1] != null) {

      try {
	return Double.parseDouble(n[0].getLabel()) == Double.parseDouble(n[1].getLabel());
      } catch (NumberFormatException nfe) {
      } catch (ModelException me) {
      }
    }

    return false;
  }
}
