package edu.stanford.db.rdf.query.orderings;

import edu.stanford.db.rdf.query.*;
import org.w3c.rdf.model.*;
import java.util.*;


/**
 * Order by a given variable name using a <tt>java.util.Comparator</tt>
 */

public class Lexicographic implements SubstitutionComparator {

  String varName;

  public Lexicographic(String varName) {

    this.varName = varName;
  }

  public int compare(Map s1, Map s2, Model m) throws ModelException {
    
    Object o1 = s1.get(varName);
    Object o2 = s2.get(varName);

    if(o1 == null && o2 != null)
      return -1;
    else if(o1 != null && o2 == null)
      return 1;
    else if(o1 == null && o2 == null)
      return 0;

    // both are non-null here

    int v = ((RDFNode)o1).getLabel().compareTo(((RDFNode)o2).getLabel());
    if(v < 0)
      return -1;
    else if(v > 0)
      return 1;
    else
      return 0;
  }
}
