package edu.stanford.db.rdf.query.util;

public class Skolem {

  Object[] array;
  int hash;

  public Skolem(Object n1) {

    array = new Object[1];
    array[0] = n1;
    computeHash();
  }

  public Skolem(Object n1, Object n2) {

    array = new Object[2];
    array[0] = n1;
    array[1] = n2;
    computeHash();
  }

  public Skolem(Object n1, Object n2, Object n3) {

    array = new Object[3];
    array[0] = n1;
    array[1] = n2;
    array[2] = n3;
    computeHash();
  }

  public Skolem(Object[] a) {

    array = a;
    computeHash();
  }

  public int hashCode() {

    return hash;
  }

  protected void computeHash() {

    hash = 0;
    for(int i = 0; i < array.length; i++)
      hash = hash * 7 + array[i].hashCode();
  }

  public boolean equals(Object that) {

    if(this == that)
      return true;
    if(that == null || !(that instanceof Skolem))
      return false;

    Skolem s = (Skolem)that;
    if(array.length != s.array.length)
      return false;

    for(int i = 0; i < array.length; i++)
      if(!array[i].equals(s.array[i]))
	return false;

    return true;
  }

  public String toString() {

    String r = "Skolem[";
    for(int i=0; i < array.length; i++) {
      if(i > 0)
	r += ", ";
      r += String.valueOf(array[i]);
    }
    return r + "]";
  }
}


  

